<?php
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require 'PHPMailer/PHPMailer/src/Exception.php';
require 'PHPMailer/PHPMailer/src/PHPMailer.php';
require 'PHPMailer/PHPMailer/src/SMTP.php';

if ($_SERVER["REQUEST_METHOD"] == "POST") {
    // Get form data
    $subject = $_POST["subject"];
    $message = $_POST["message"];
    $recipientType = $_POST["recipient"];
    $specificEmail = isset($_POST["specificEmail"]) ? $_POST["specificEmail"] : null;

    // Create a PHPMailer instance
    $mail = new PHPMailer(true);

    // Initialize response data
    $response = [
        'success' => false,
        'status' => 500,
        'error' => '',
        'sentTo' => []
    ];

    try {
        // Server settings (adjust as needed)
        $mail->isSMTP();
        $mail->Host       = 'signifx.com';
        $mail->SMTPAuth   = true;
        $mail->Username   = 'sms@signifx.com';
        $mail->Password   = 'sms@@signifx.com';
        $mail->SMTPSecure = 'ssl';
        $mail->Port       = 465;

        // Content
        $mail->isHTML(true);
        $mail->Subject = $subject;
        $mail->Body    = $message;

        // Depending on the recipient type, set sender and send emails
        if ($recipientType === "all") {
            // Set a generic sender for all subscribers
            $mail->setFrom('sms@signifx.com', 'Your Website');
            
            // Get all subscribers from the database and send emails
            // Adjust the database connection details
            $dbHost = 'localhost';
            $dbName = 'signimkw_signifx_newslater';
            $dbUser = 'signimkw_signifx_newslater';
            $dbPass = 'signimkw_signifx_newslater';

            $conn = new PDO("mysql:host=$dbHost;dbname=$dbName", $dbUser, $dbPass);

            $stmt = $conn->prepare("SELECT subscriber_emails FROM subscribers");
            $stmt->execute();

            while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                $mail->clearAddresses(); // Clear any previous addresses

                // Validate email address before sending
                if (filter_var($row['subscriber_emails'], FILTER_VALIDATE_EMAIL)) {
                    $mail->addAddress($row['subscriber_emails']);
                    $mail->send();
                    $response['sentTo'][] = $row['subscriber_emails'];
                }
            }
        } elseif ($recipientType === "specific") {
            // Set the specific sender for the specific recipient
            $mail->setFrom('sms@signifx.com', 'Specific Sender');

            // Validate email address before sending
            if (filter_var($specificEmail, FILTER_VALIDATE_EMAIL)) {
                $mail->addAddress($specificEmail);
                $mail->send();
                $response['sentTo'][] = $specificEmail;
            } else {
                $response['error'] = 'Invalid email address';
                echo json_encode($response);
                exit();
            }
        }

        // Success response
        $response['success'] = true;
        $response['status'] = 200;
        unset($response['error']); // Remove the "error" field for success
        echo json_encode($response);
        exit();


    } catch (Exception $e) {
        // Log error
        $error_message = "Email(s) could not be sent. Mailer Error: {$mail->ErrorInfo}";
        error_log($error_message, 3, 'error.log');

        // Failure response
        $response['error'] = $error_message;
        echo json_encode($response);
        exit();
    }
}
?>
